Index: debian/control
===================================================================
--- debian/control	(revision 59766)
+++ debian/control	(working copy)
@@ -3,7 +3,7 @@
 Section: debian-installer
 Maintainer: Debian Install System Team <debian-boot@lists.debian.org>
 Uploaders: Jérémy Bobbio <lunar@debian.org>, Colin Watson <cjwatson@debian.org>, Christian Perrier <bubulle@debian.org>
-Build-Depends: debhelper (>= 6.0.0), po-debconf (>= 0.5.0), libdebian-installer4-dev, libdebconfclient0-dev (>= 0.139), libnewt-dev, libgtk-directfb-2.0-dev, libvte-dev (>> 0.16.14-1)
+Build-Depends: debhelper (>= 6.0.0), po-debconf (>= 0.5.0), libdebian-installer4-dev, libdebconfclient0-dev (>= 0.146), libnewt-dev, libgtk-directfb-2.0-dev, libvte-dev (>> 0.16.14-1)
 Standards-Version: 3.8.1
 Vcs-Svn: svn://svn.debian.org/d-i/trunk/packages/cdebconf-terminal
 
@@ -20,7 +20,7 @@
 Package: cdebconf-newt-terminal
 Architecture: any
 Section: debian-installer
-Depends: cdebconf-newt-udeb, ${shlibs:Depends}, ${misc:Depends}
+Depends: cdebconf-newt-udeb (>= 0.146), ${shlibs:Depends}, ${misc:Depends}
 Provides: cdebconf-terminal
 XC-Package-Type: udeb
 Description: cdebconf newt plugin to provide a clean terminal
Index: newt-plugin-terminal.c
===================================================================
--- newt-plugin-terminal.c	(revision 59766)
+++ newt-plugin-terminal.c	(working copy)
@@ -166,9 +166,9 @@
 int
 cdebconf_newt_handler_terminal(struct frontend *obj, struct question *q)
 {
-    char *saved_progress_title = NULL;
+    struct question *saved_progress_title = NULL;
     int saved_progress_min, saved_progress_max, saved_progress_cur;
-    char *saved_progress_info = NULL;
+    struct question *saved_progress_info = NULL;
     const char *command_line;
     const char *term;
     char *bterm_tempdir = NULL;
@@ -178,12 +178,16 @@
 
     /* Tear down newt. */
     newtPopHelpLine();
-    if (obj->progress_title)
-        saved_progress_title = strdup(obj->progress_title);
+    if (obj->progress_title) {
+        saved_progress_title = obj->progress_title;
+        question_ref(saved_progress_title);
+    }
     saved_progress_min = obj->progress_min;
     saved_progress_max = obj->progress_max;
     saved_progress_cur = obj->progress_cur;
     saved_progress_info = cdebconf_newt_get_progress_info(obj);
+    if (saved_progress_info)
+        question_ref(saved_progress_info);
     newtFinished();
 
     command_line = question_get_variable(q, "COMMAND_LINE");
@@ -285,11 +289,11 @@
         obj->methods.progress_start(obj,
                                     saved_progress_min, saved_progress_max,
                                     saved_progress_title);
-        free(saved_progress_title);
+        question_deref(saved_progress_title);
         obj->methods.progress_set(obj, saved_progress_cur);
         if (saved_progress_info) {
             obj->methods.progress_info(obj, saved_progress_info);
-            free(saved_progress_info);
+            question_deref(saved_progress_info);
         }
     }
 
